 Program

! This program (The good and the bad parts) was written by Jeff Slarve
! Requires the redirection class from Clarion Magazine
! Version 1.0a !Added the display of the icons

  Include('jsredir.inc') ! Get this from Clarion Magazine http://www.clarionmag.com/cmag/v2/v2n12redir.html

   map
     Dialog(),Byte
     FixPath(String pInPath,Byte IsFolder=True),String
   end

JSR        Class(JSRedirClass)
AddDefaultMacros  Procedure,Derived
           end

IconQ      Queue
Icon         String(File:MaxFilePath) !Name of the icon
Icon_Icon    Short
Apps         String(2000)             !Comma delimited names of the apps that used it
           end

FQ         Queue(File:Queue),Pre(FQ)  !For calling Directory(). gets all of the .lnk files
           end

CWRootPath String(File:MaxFilePath)   !Used for getting the %ROOT% macro
FolderName String(File:MaxFilePath)   !Folder where the apps are
RedirFile  String(File:MaxFilePath)   !Filename for the CW .RED file
SavePath   String(File:MaxFilePath)   !Keeps track of initial path
Inifile    Equate('.\iconused.ini')   !Ini file..

Ndx        Long                       !Generic counter

LNKFile    File,Driver('ASCII'),PRE(LNK),Name(FQ.Name),Create !For opening and processing the .LNK files.   The CREATE attribute is only used for saving a text file.
Record       Record
FileName       String(File:MaxFilePath)
             end
           end


Window WINDOW('Caption'),AT(,,523,241),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI),CENTER,IMM, |
         SYSTEM,GRAY,MAX,RESIZE
       LIST,AT(3,3,517,219),USE(?List1),VSCROLL,FORMAT('213L(2)|MI~Icon~C(0)@s255@20L(2)|M~Apps Where Used~C(0)@s255@'), |
           FROM(IconQ)
       BUTTON('&Save Icon List'),AT(410,226,63,12),USE(?SaveButton)
       BUTTON('&Close'),AT(476,226,45,12),USE(?Close),STD(std:close)
     END

  Code

  SavePath = LongPath()
  If NOT Dialog() then return.

  If RedirFile AND CWRootPath                             !If you fill in these fields on the window, then the Redirection file will be used and the full paths to these icons will be given.
    JSR.AddMacro('ROOT', Clip(FixPath(CWRootPath)))
    !JSR.AddMacro('_UTDIR_','E:\C55\3RDPARTY\ULTRAT~1')   !If you have Ultra Tree, set this to your ultra tree folder
    JSR.ParseRedirFile(RedirFile,'Common')
    JSR.ValidateRedirQ()
  end

  SetPath(FolderName)
  Directory(FQ,Clip(FolderName) & '\*.lnk',ff_:Normal)

  If NOT Records(FQ)
    Message('No .LNK files')
    Return
  end


  Loop Ndx = 1 to Records(FQ)
    Get(FQ,Ndx)
    Close(LNKFile)
    Open(LNKFile)
    If ErrorCode()
      Message('Error Opening ' & Clip(FQ.Name) & '||' & Error(),'Error',ICON:Exclamation)
      Break
    end
    Set(LNKFile)
    Loop
      Next(LNKFile)
      If errorCode() then break.
      If Instring('.ICO',Upper(LNK:FileName),1,1)
        If SUB(LNK:FileName,1,13 ) = '/PROGRAM_ICON'
          LNK:FileName = SUB(LNK:FileName,15,Len(LNK:FileName))
        end
        JSR.FindFilePath(LNK:FileName,IconQ.icon)
        Get(IconQ,IconQ.Icon)
        If ErrorCode()
          JSR.FindFilePath(LNK:FileName,IconQ.icon)
          IconQ.Apps = Sub(FQ.Name,1,Len(Clip(FQ.Name))-4)
          Add(IconQ)
        else
          IconQ.Apps = Clip(IconQ.Apps) & ', ' & Sub(FQ.Name,1,Len(Clip(FQ.Name))-4)
          Put(IconQ)
        end
      end
    end
  end
  Close(LnkFile)

  Sort(IconQ,IconQ.Icon)

  SetPath(SavePath)

  Open(Window)
  0{PROP:Text} = Records(IconQ) & ' icons used in ' & Clip(FolderName) & ' using ' & Clip(RedirFile)
  0{PROP:Height} =  GetINI('WindowSettings','H',250,Inifile)
  0{PROP:Width} =  GetINI('WindowSettings','W',500,Inifile)
  Loop Ndx = 1 to 255
    Get(IconQ,Ndx)
    If ErrorCode() then break.
    ?List1{PROP:IconList,Ndx} = IconQ.Icon
    IconQ.Icon_Icon = Ndx
    Put(IconQ)
  end
  ?List1{PROP:LineHeight} = 25
  Accept
    Case Event()
    of Event:Sized
      ?List1{PROP:XPos} = 2
      ?List1{PROP:YPos} = 2
      ?List1{PROP:Width} = 0{PROP:Width}-4
      ?List1{PROP:Height} = 0{PROP:Height}-18
      ?Close{PROP:XPos} = 0{PROP:Width} - ?Close{PROP:Width} - 2
      ?Close{PROP:YPos} = 0{PROP:Height} - 14
      ?SaveButton{PROP:XPos} = ?Close{PROP:XPos} - ?SaveButton{PROP:Width} - 2
      ?SaveButton{PROP:YPos} = ?Close{PROP:YPos}
    of Event:CloseWindow
      PutINI('WindowSettings','H',0{PROP:Height},Inifile)
      PutINI('WindowSettings','W',0{PROP:Width},Inifile)
    of Event:Accepted
      If Field() = ?SaveButton
        Close(LNKFile) !Just in case it's open somewhere <G>
        !Since we already have this file declared, I'll just use it again here. After all, I don't have all day.
        Free(FQ)
        Clear(FQ)
        FQ.Name = 'Iconlist.txt'
        If FileDialog('Select FileName',FQ.Name,'Text Files|*.txt',File:NoError+File:LongName+File:Save+File:KeepDir)
           Create(LNKFile)
           If ErrorCode()
             Message('Error Creating ' & Clip(FQ.Name) & '||' & Error(), 'Error', ICON:Exclamation)
            else
              Open(LNKFile)
              If ErrorCode()
                Message('Error Opening ' & Clip(FQ.Name) & '||' & Error(), 'Error', ICON:Exclamation)
              else
                Loop Ndx = 1 to Records(IconQ)
                  Get(IconQ,Ndx)
                  LNK:FileName = IconQ.Icon
                  Add(LNKFile)
                end
                Close(LNKFile)
              end
           end
        end
      end
    end
  end


JSR.AddDefaultMacros Procedure

  Code

  !Do Nothing until we have values filled in the dialog.
  !If this derived procedure weren't here, then the default one would have been called from the parent constructor.

Dialog Procedure

DialogWindow WINDOW('Icon Searcher'),AT(,,421,56),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI), |
         CENTER,SYSTEM,GRAY,DOUBLE
       PROMPT('Application Folder:'),AT(3,3),USE(?AppFolderPrompt)
       ENTRY(@s255),AT(67,3,339,10),USE(FolderName),TIP('Folder where your application is'),REQ
       BUTTON('...'),AT(409,3,10,10),USE(?AppFolderLookupButton),TIP('Look up Application Folder')
       PROMPT('Redirection File:'),AT(3,16),USE(?RedirFilePrompt)
       ENTRY(@s255),AT(67,16,339,10),USE(RedirFile),TIP('Your CW Redir file, so the icons can be located.')
       BUTTON('...'),AT(409,16,10,10),USE(?RedirLookupButton),TIP('Look up Application Folder')
       PROMPT('CW Root Folder:'),AT(3,29),USE(?CWRootPrompt)
       ENTRY(@s255),AT(67,29,339,10),USE(CWRootPath),TIP('Your CW Redir file, so the icons can be located.')
       BUTTON('...'),AT(409,29,10,10),USE(?CWFolderLookupButton),TIP('Look up Application Folder')
       BUTTON('&OK'),AT(335,42,40,12),USE(?OKButton),DEFAULT
       BUTTON('&Cancel'),AT(378,42,40,12),USE(?CancelButton),STD(std:close)
     END

  Code

  FolderName  = GetINI('iconused','Appfolder',,Inifile)
  RedirFile  = GetINI('iconused','RedirFile',,Inifile)
  CWRootPath = GetINI('iconused','CWrootPath',,Inifile)

  Open(DialogWIndow)
  Accept
    Case Accepted()
    of ?AppFolderLookupButton
      If FileDialog('Select App Folder',FolderName,'*.*',File:Directory+File:LongName+File:KeepDir)
        Select(?FolderName)
      end
    of ?RedirLookupButton
      If FileDialog('Select Redirection File',RedirFile,'Redirection Files|*.red',File:KeepDir+File:LongName)
        Select(?RedirFile)
      end
    of ?CWFolderLookupButton
      If FileDialog('Select CW Root Folder',CWRootPath,'*.*',File:Directory+File:LongName+File:KeepDir)
        Select(?CWRootPath)
      end
    of ?OKButton
      If Incomplete()
        Select(Incomplete())
      else
        PutINI('iconused','Appfolder',FolderName,Inifile)
        PutINI('iconused','RedirFile',RedirFile,Inifile)
        PutINI('iconused','CWrootPath',CWRootPath,Inifile)
        Return True
      end
    end
  end

  Return False

!============================================================================================================================================================
FixPath              PROCEDURE  (String pInPath,Byte IsFolder=True)
!Adds a backslash to the end of a file if it doesn't exist
!============================================================================================================================================================
ReturnVal CString(File:MaxFilePath)

  CODE

 ReturnVal = Clip(pInPath)
! Loop
!   Ndx       = Instring('/',ReturnVal,1,1)                               !Replace any forward slashes with backslashes
!   If not Ndx then break.
!   ReturnVal[Ndx] = '\'
! end
 Loop Ndx = 1 to File:MaxFilePath - 1
   Case ReturnVal[Ndx]
   of '/'
     ReturnVal[Ndx] = '\'
   of '?' orof '*'
     ReturnVal[Ndx] = '_'
   end
 end
 
 Loop
   Ndx       = Instring('\\',ReturnVal,1,2)                              !If there are any doubled up backslashes, then fix it
   If not Ndx then break.
   Case Ndx
   of 1
     ReturnVal = ReturnVal[2 : Len(ReturnVal)]
   of Len(Returnval) - 1
     ReturnVal = ReturnVal[1: Len(ReturnVal) - 1]
   else
     ReturnVal = ReturnVal[1 : Ndx] & ReturnVal[Ndx+2 : Len(ReturnVal)]
   end
 end
 If IsFolder
   ReturnVal = ReturnVal & Choose(Sub(ReturnVal,-1,1)='\', '','\') !Ensure that the last character of the path is a backslash
 end  
 Return ReturnVal